
Redmine - Defect #34297

Subprojects issues are not displayed on main project when all subprojects are closed

2020-11-23 01:34 - huijun Kim

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee: Go MAEDA % Done: 0%

Category: Issues list Estimated time: 0.00 hour

Target version: 4.0.8   

Resolution: Fixed Affected version: 4.1.1

Description

No issues are displayed on issue page

parent project (open)

  - subproject1 (closed)

  - subproject2 (closed)

 It shows sub1, sub2 issues.

parent project (open)

  - subproject1 (closed)

  - subproject2 (open)

Related issues:

Related to Redmine - Defect #34375: "is not" operator for Subproject filter i... Closed

Associated revisions

Revision 20693 - 2020-12-27 07:46 - Go MAEDA

Subprojects issues are not displayed on main project when all subprojects are closed (#34297).

Patch by Yuichi HARADA and Go MAEDA.

Revision 20694 - 2020-12-28 01:52 - Go MAEDA

Make sure that "is not" operator for Subproject filter does not exclude closed subprojects (#34375).

The issue has been fixed in r20693 along with #34297.

Revision 20695 - 2020-12-29 07:57 - Go MAEDA

Merged r20693 from trunk to 4.1-stable (#34297).

Revision 20696 - 2020-12-29 08:07 - Go MAEDA

Merged r20693 from trunk to 4.0-stable (#34297).

History

#1 - 2020-11-23 05:42 - Go MAEDA

- Status changed from New to Confirmed

I have confirmed the reported behavior. If there are one or more open subprojects, issues in closed subprojects are visible in a parent project's issues

list. However, if all subprojects are closed, all issues from subprojects are invisible.

#2 - 2020-12-02 08:19 - Go MAEDA

- Subject changed from  The issue is not visible when closing all subprojects. to Subprojects issues are not displayed on main project when all

subprojects are closed

#3 - 2020-12-03 07:12 - Go MAEDA

- Related to Defect #34375: "is not" operator for Subproject filter incorrectly excludes closed subprojects added
#4 - 2020-12-03 09:20 - Yuichi HARADA

- File fixed-34297.patch added

Go MAEDA wrote:

I have confirmed the reported behavior. If there are one or more open subprojects, issues in closed subprojects are visible in a parent project's

issues list. However, if all subprojects are closed, all issues from subprojects are invisible.

 I created a patch. I fix to show subprojects issues even if all subprojects are closed.

#5 - 2020-12-06 05:20 - Go MAEDA

- Target version set to Candidate for next major release

#6 - 2020-12-20 09:38 - Go MAEDA

Yuichi HARADA wrote:

I created a patch. I fix to show subprojects issues even if all subprojects are closed.

 Thank you for posting the patch.

What do you think about the following approach? The number of lines to be changed is minimal, and also fixes #34375.

diff --git a/app/models/query.rb b/app/models/query.rb

index 18f1b135b..8ed09579d 100644

--- a/app/models/query.rb

+++ b/app/models/query.rb

@@ -898,10 +898,10 @@ class Query < ActiveRecord::Base

   def project_statement

     project_clauses = []

-    active_subprojects_ids = []

+    non_archived_subprojects_ids = []

-    active_subprojects_ids = project.descendants.active.map(&:id) if project

-    if active_subprojects_ids.any?

+    non_archived_subprojects_ids = project.descendants.where.not(status: Project::STATUS_ARCHIVED).ids if pro

ject

+    if non_archived_subprojects_ids.any?

       if has_filter?("subproject_id")

         case operator_for("subproject_id")

         when '='

@@ -910,7 +910,7 @@ class Query < ActiveRecord::Base

           project_clauses << "#{Project.table_name}.id IN (%s)" % ids.join(',')

         when '!'

           # exclude the selected subprojects

-          ids = [project.id] + active_subprojects_ids - values_for("subproject_id").map(&:to_i)

+          ids = [project.id] + non_archived_subprojects_ids - values_for("subproject_id").map(&:to_i)

           project_clauses << "#{Project.table_name}.id IN (%s)" % ids.join(',')

         when '!*'

           # main project only

#7 - 2020-12-23 06:35 - Yuichi HARADA

Go MAEDA wrote:

What do you think about the following approach? The number of lines to be changed is minimal, and also fixes #34375.

[...]

 That's great. I have confirmed that #34375 is also improved with minimal changes.

#8 - 2020-12-23 12:31 - Go MAEDA

- File 34297-v2.patch added

Yuichi HARADA wrote:

Go MAEDA wrote:
What do you think about the following approach? The number of lines to be changed is minimal, and also fixes #34375.

[...]

 That's great. I have confirmed that #34375 is also improved with minimal changes.

 Thank you for checking the code. I have updated the patch:

Combined the code in #34297#note-6 and tests in fixed-34297.patch

Simplified tests

#9 - 2020-12-25 06:15 - Go MAEDA

- Target version changed from Candidate for next major release to 4.0.8

Setting the target version to 4.0.8.

#10 - 2020-12-27 07:47 - Go MAEDA

- Status changed from Confirmed to Resolved

- Assignee set to Go MAEDA

Committed the patch.

#11 - 2020-12-29 08:07 - Go MAEDA

- Status changed from Resolved to Closed

- Resolution set to Fixed

Files

fixed-34297.patch 5.24 KB 2020-12-03 Yuichi HARADA

34297-v2.patch 3.15 KB 2020-12-23 Go MAEDA
